#ifndef __ASM_I386__
#define __ASM_I386__

#ifdef ELF
#define label label
#else
#define label _##label
#endif


//#define GLQUAKE	1

#if defined(_WIN32) && !defined(WINDED)

#if defined(_M_IX86)
#define __i386__	1
#endif

#endif

#ifdef __i386__
#define id386	1
#else
#define id386	0
#endif

// !!! must be kept the same as in d_iface.h !!!
#define TRANSPARENT_COLOR	255

#ifndef GLQUAKE
	.extern d_zistepu
	.extern d_pzbuffer
	.extern d_zistepv
	.extern d_zrowbytes
	.extern d_ziorigin
	.extern r_turb_s
	.extern r_turb_t
	.extern r_turb_pdest
	.extern r_turb_spancount
	.extern r_turb_turb
	.extern r_turb_pbase
	.extern r_turb_sstep
	.extern r_turb_tstep
	.extern	r_bmodelactive
	.extern	d_sdivzstepu
	.extern	d_tdivzstepu
	.extern	d_sdivzstepv
	.extern	d_tdivzstepv
	.extern	d_sdivzorigin
	.extern	d_tdivzorigin
	.extern	sadjust
	.extern	tadjust
	.extern	bbextents
	.extern	bbextentt
	.extern	cacheblock
	.extern	d_viewbuffer
	.extern	cachewidth
	.extern	d_pzbuffer
	.extern	d_zrowbytes
	.extern	d_zwidth
	.extern d_scantable
	.extern r_lightptr
	.extern r_numvblocks
	.extern prowdestbase
	.extern pbasesource
	.extern r_lightwidth
	.extern lightright
	.extern lightrightstep
	.extern lightdeltastep
	.extern lightdelta
	.extern lightright
	.extern lightdelta
	.extern sourcetstep
	.extern surfrowbytes
	.extern lightrightstep
	.extern lightdeltastep
	.extern r_sourcemax
	.extern r_stepback
	.extern colormap
	.extern blocksize
	.extern sourcesstep
	.extern lightleft
	.extern blockdivshift
	.extern blockdivmask
	.extern lightleftstep
	.extern r_origin
	.extern r_ppn
	.extern r_pup
	.extern r_pright
	.extern ycenter
	.extern xcenter
	.extern d_vrectbottom_particle
	.extern d_vrectright_particle
	.extern d_vrecty
	.extern d_vrectx
	.extern d_pix_shift
	.extern d_pix_min
	.extern d_pix_max
	.extern d_y_aspect_shift
	.extern screenwidth
	.extern r_leftclipped
	.extern r_leftenter
	.extern r_rightclipped
	.extern r_rightenter
	.extern modelorg
	.extern xscale
	.extern r_refdef
	.extern yscale
	.extern r_leftexit
	.extern r_rightexit
	.extern r_lastvertvalid
	.extern cacheoffset
	.extern newedges
	.extern removeedges
	.extern r_pedge
	.extern r_framecount
	.extern r_u1
	.extern r_emitted
	.extern edge_p
	.extern surface_p
	.extern surfaces
	.extern r_lzi1
	.extern r_v1
	.extern r_ceilv1
	.extern r_nearzi
	.extern r_nearzionly
	.extern edge_aftertail
	.extern edge_tail
	.extern current_iv
	.extern edge_head_u_shift20
	.extern span_p
	.extern edge_head
	.extern fv
	.extern edge_tail_u_shift20
	.extern r_apverts
	.extern r_anumverts
	.extern aliastransform
	.extern r_avertexnormals
	.extern r_plightvec
	.extern r_ambientlight
	.extern r_shadelight
	.extern aliasxcenter
	.extern aliasycenter
	.extern a_sstepxfrac
	.extern r_affinetridesc
	.extern acolormap
	.extern d_pcolormap
	.extern r_affinetridesc
	.extern d_sfrac
	.extern d_ptex
	.extern d_pedgespanpackage
	.extern d_tfrac
	.extern d_light
	.extern d_zi
	.extern d_pdest
	.extern d_pz
	.extern d_aspancount
	.extern erroradjustup
	.extern errorterm
	.extern d_xdenom
	.extern r_p0
	.extern r_p1
	.extern r_p2
	.extern a_tstepxfrac
	.extern r_sstepx
	.extern r_tstepx
	.extern a_ststepxwhole
	.extern zspantable
	.extern skintable
	.extern r_zistepx
	.extern erroradjustdown
	.extern d_countextrastep
	.extern ubasestep
	.extern a_ststepxwhole
	.extern a_tstepxfrac
	.extern r_lstepx
	.extern a_spans
	.extern erroradjustdown
	.extern d_pdestextrastep
	.extern d_pzextrastep
	.extern d_sfracextrastep
	.extern d_ptexextrastep
	.extern d_countextrastep
	.extern d_tfracextrastep
	.extern d_lightextrastep
	.extern d_ziextrastep
	.extern d_pdestbasestep
	.extern d_pzbasestep
	.extern d_sfracbasestep
	.extern d_ptexbasestep
	.extern ubasestep
	.extern d_tfracbasestep
	.extern d_lightbasestep
	.extern d_zibasestep
	.extern zspantable
	.extern r_lstepy
	.extern r_sstepy
	.extern r_tstepy
	.extern r_zistepy
	.extern D_PolysetSetEdgeTable
	.extern D_RasterizeAliasPolySmooth

	.extern float_point5
	.extern Float2ToThe31nd
	.extern izistep
	.extern izi
	.extern FloatMinus2ToThe31nd
	.extern float_1
	.extern float_particle_z_clip
	.extern float_minus_1
	.extern float_0
	.extern fp_16
	.extern fp_64k
	.extern fp_1m
	.extern fp_1m_minus_1
	.extern fp_8 
	.extern entryvec_table
	.extern advancetable
	.extern sstep
	.extern tstep
	.extern pspantemp
	.extern counttemp
	.extern jumptemp
	.extern reciprocal_table
	.extern DP_Count
	.extern DP_u
	.extern DP_v
	.extern DP_32768
	.extern DP_Color
	.extern DP_Pix
	.extern DP_EntryTable
	.extern	pbase
	.extern s
	.extern t
	.extern sfracf
	.extern tfracf
	.extern snext
	.extern tnext
	.extern	spancountminus1
	.extern zi16stepu
	.extern sdivz16stepu
	.extern tdivz16stepu
	.extern	zi8stepu
	.extern sdivz8stepu
	.extern tdivz8stepu
	.extern reciprocal_table_16
	.extern entryvec_table_16
	.extern ceil_cw
	.extern single_cw
	.extern fp_64kx64k
	.extern pz
	.extern spr8entryvec_table
#endif

	.extern snd_scaletable
	.extern paintbuffer
	.extern snd_linear_count
	.extern snd_p
	.extern snd_vol
	.extern snd_out
	.extern vright
	.extern vup
	.extern vpn
	.extern BOPS_Error

//
// !!! note that this file must match the corresponding C structures at all
// times !!!
//

// plane_t structure
// !!! if this is changed, it must be changed in model.h too !!!
// !!! if the size of this is changed, the array lookup in SV_HullPointContents
//     must be changed too !!!
#define pl_normal	0
#define pl_dist		12
#define pl_type		16
#define pl_signbits	17
#define pl_pad		18
#define pl_size		20

// hull_t structure
// !!! if this is changed, it must be changed in model.h too !!!
#define	hu_clipnodes		0
#define	hu_planes			4
#define	hu_firstclipnode	8
#define	hu_lastclipnode		12
#define	hu_clip_mins		16
#define	hu_clip_maxs		28
#define hu_size  			40

// dnode_t structure
// !!! if this is changed, it must be changed in bspfile.h too !!!
#define	nd_planenum		0
#define	nd_children		4
#define	nd_mins			8
#define	nd_maxs			20
#define	nd_firstface	32
#define	nd_numfaces		36
#define nd_size			40

// sfxcache_t structure
// !!! if this is changed, it much be changed in sound.h too !!!
#define sfxc_length		0
#define sfxc_loopstart	4
#define sfxc_speed		8
#define sfxc_width		12
#define sfxc_stereo		16
#define sfxc_data		20

// channel_t structure
// !!! if this is changed, it much be changed in sound.h too !!!
#define ch_sfx			0
#define ch_leftvol		4
#define ch_rightvol		8
#define ch_end			12
#define ch_pos			16
#define ch_looping		20
#define ch_entnum		24
#define ch_entchannel	28
#define ch_origin		32
#define ch_dist_mult	44
#define ch_master_vol	48
#define ch_size			52

// portable_samplepair_t structure
// !!! if this is changed, it much be changed in sound.h too !!!
#define psp_left		0
#define psp_right		4
#define psp_size		8


//
// !!! note that this file must match the corresponding C structures at all
// times !!!
//

// !!! if this is changed, it must be changed in r_local.h too !!!
#define	NEAR_CLIP	0.01

// !!! if this is changed, it must be changed in r_local.h too !!!
#define	CYCLE	128

// espan_t structure
// !!! if this is changed, it must be changed in r_shared.h too !!!
#define espan_t_u    	0
#define espan_t_v	    4
#define espan_t_count   8
#define espan_t_pnext	12
#define espan_t_size    16

// sspan_t structure
// !!! if this is changed, it must be changed in d_local.h too !!!
#define sspan_t_u    	0
#define sspan_t_v	    4
#define sspan_t_count   8
#define sspan_t_size    12

// spanpackage_t structure
// !!! if this is changed, it must be changed in d_polyset.c too !!!
#define spanpackage_t_pdest				0
#define spanpackage_t_pz				4
#define spanpackage_t_count				8
#define spanpackage_t_ptex				12
#define spanpackage_t_sfrac				16
#define spanpackage_t_tfrac				20
#define spanpackage_t_light				24
#define spanpackage_t_zi				28
#define spanpackage_t_size				32 

// edge_t structure
// !!! if this is changed, it must be changed in r_shared.h too !!!
#define et_u			0
#define et_u_step		4
#define et_prev			8
#define et_next			12
#define et_surfs		16
#define et_nextremove	20
#define et_nearzi		24
#define et_owner		28
#define et_size			32

// surf_t structure
// !!! if this is changed, it must be changed in r_shared.h too !!!
#define SURF_T_SHIFT	6
#define st_next			0
#define st_prev			4
#define st_spans		8
#define st_key			12
#define st_last_u		16
#define st_spanstate	20
#define st_flags		24
#define st_data			28
#define st_entity		32
#define st_nearzi		36
#define st_insubmodel	40
#define st_d_ziorigin	44
#define st_d_zistepu	48
#define st_d_zistepv	52
#define st_pad			56
#define st_size			64

// clipplane_t structure
// !!! if this is changed, it must be changed in r_local.h too !!!
#define cp_normal		0
#define cp_dist			12
#define cp_next			16
#define cp_leftedge		20
#define cp_rightedge	21
#define cp_reserved		22
#define cp_size			24

// medge_t structure
// !!! if this is changed, it must be changed in model.h too !!!
#define me_v				0
#define me_cachededgeoffset	4
#define me_size				8

// mvertex_t structure
// !!! if this is changed, it must be changed in model.h too !!!
#define mv_position		0
#define mv_size			12

// refdef_t structure
// !!! if this is changed, it must be changed in render.h too !!!
#define rd_vrect					0
#define rd_aliasvrect				20
#define rd_vrectright				40
#define rd_vrectbottom				44
#define rd_aliasvrectright			48
#define rd_aliasvrectbottom			52
#define rd_vrectrightedge			56
#define rd_fvrectx					60
#define rd_fvrecty					64
#define rd_fvrectx_adj				68
#define rd_fvrecty_adj				72
#define rd_vrect_x_adj_shift20		76
#define rd_vrectright_adj_shift20	80
#define rd_fvrectright_adj			84
#define rd_fvrectbottom_adj			88
#define rd_fvrectright				92
#define rd_fvrectbottom				96
#define rd_horizontalFieldOfView	100
#define rd_xOrigin					104
#define rd_yOrigin					108
#define rd_vieworg					112
#define rd_viewangles				124
#define rd_ambientlight				136
#define rd_size						140

// mtriangle_t structure
// !!! if this is changed, it must be changed in model.h too !!!
#define mtri_facesfront		0
#define mtri_vertindex		4
#define mtri_size			16	// !!! if this changes, array indexing in !!!
								// !!! d_polysa.s must be changed to match !!!
#define mtri_shift			4

#endif
